SystemOrganization addCategory: #ActorExamples!

ActorBehavior subclass: #CounterActor
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActorExamples'!

!CounterActor methodsFor: 'as yet unclassified' stamp: 'tonyg 2/17/2018 19:40'!
add: aNumber
	count := count + aNumber.
	^ count! !

!CounterActor methodsFor: 'as yet unclassified' stamp: 'tonyg 2/17/2018 19:40'!
count
	^ count! !

!CounterActor methodsFor: 'as yet unclassified' stamp: 'tonyg 2/17/2018 19:40'!
increment
	^ self add: 1! !

!CounterActor methodsFor: 'as yet unclassified' stamp: 'tonyg 2/17/2018 19:40'!
initialize
	super initialize.
	count := 0.! !

ActorBehavior subclass: #PingPong1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActorExamples'!

!PingPong1 methodsFor: 'as yet unclassified' stamp: 'tonyg 2/18/2018 18:20'!
increment: aCounter times: count
    count = 0 ifTrue: [^self].
    self logAll: 'Synchronously pinging ', aCounter printString.
    aCounter increment >>= [ :incrementedValue |
        self increment: aCounter times: count - 1 ] bindActor.
! !

ActorBehavior subclass: #PingPong2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ActorExamples'!

!PingPong2 methodsFor: 'as yet unclassified' stamp: 'tonyg 2/18/2018 18:50'!
linkTo: anActorProxy
	anActorProxy actor link.! !

!PingPong2 methodsFor: 'as yet unclassified' stamp: 'tonyg 2/18/2018 18:39'!
ping: peer times: count
    count = 0 ifTrue: [^self].
    self logAll: 'Asynchronously pinging ', peer printString.
    peer async ping: Actor me times: count - 1.
! !
